#!/usr/local/bin/perl
#------------------------------------------------
$VERSION="3.02";
$RCFILE="$ENV{HOME}/.imagemailrc";
$TEMPFILE="$ENV{HOME}/imgmail$$tmp.ish";
#$TEMPFILE="/usr/tmp/imgmail$$tmp.ish";
#------------------------------------------------
sub formatcheck
{
	local($_)=@_;
	return	"lha"		if /\.lzh$/i;
	return	"tar+compress"	if /\.tar\.Z$/  || /\.taz$/i;
	return	"tar+gzip"	if /\.tar\.gz$/ || /\.tgz$/i;
#	return	"tar+oldgzip"	if /\.tar\.z$/;
	return	"compress"	if /\.Z$/;
	return	"gzip"		if /\.gz$/;
	return	"unknown format";
}
#------------------------------------------------
sub addfile
{
	local($old)= select(shift);
	if( open( SIG, @_ ) ){
		while(<SIG>){
			print;
		}
		close( SIG );
	}
	select($old);
}
#------------------------------------------------
sub addsignature
{
	local($old)= select(shift);
	local($sigfile)="$ENV{HOME}/.signature-imagemail";
	unless( -r $sigfile ){
		$sigfile="$ENV{HOME}/.signature-automail";
		unless( -r $sigfile ){
			$sigfile="$ENV{HOME}/.signature";
		}
	}
	if( -r $sigfile ){
		print( "--\n" );
		&addfile( select, $sigfile );
		print( "\n" );
	}
	select($old);
}
#------------------------------------------------
sub getromname
{
	local($name)=$ENV{FULLNAME};
	local(@pw);
	return	$name	if $name ne "";
	$name=$ENV{USER};
	if( $name eq "" ){
		$name=$ENV{LOGNAME};
		if( $name eq "" ){
			$name=getlogin;
			if( $name eq "" ){
				$name=`whoami`;
			}
		}
	}
	@pw= getpwnam( $name );
	@pw= split( ",", $pw[6] );
	return	$pw[0]	if $pw[0] ne "";
	return	$name;
}
#------------------------------------------------
sub getimailrc
{
	local(@rcline);
	if( open( IMFILE, $_[0] ) ){
		while(<IMFILE>){
			unless( /^#/ ){
				chop;
				@rcline=split(" |\t",$_,2);
				$RC{$rcline[0]}=$rcline[1];
			}
		}
		close( IMFILE );
	}
}
#------------------------------------------------
sub datainput
{
	local($line);
	print "input: ";
	$line=<STDIN>;
	chop $line;
	return	$line;
}
#------------------------------------------------
sub changeparam
{
	local($line);
	print( "Do you change this parameter? (y/n) " );
	$line=<STDIN>;
	chop $line;
	if( $line eq "y" || $line eq "Y" ){
		$line= &datainput;
		return	$line	if $line ne "";
	}
	print "not changed.\n";
	return	$_[0];
}
#------------------------------------------------
# main
&getimailrc( $RCFILE );
$MAXLINE= $RC{'maxline'} ? $RC{'maxline'} : 512;
$SLEEPTIME=$RC{'sleep'} ? $RC{'sleep'}*60 : 60*60;
$H_ROMNAME=$RC{'name'} ? $RC{'name'} : &getromname;
$H_ADDRESS= $RC{'address'};
$H_JNAME= $RC{'jname'};
$LOGFILE= $RC{'logfile'} ? $RC{'logfile'} : "~/imagemail.log" ;
$LOGFILE=~s/\~/$ENV{HOME}/;
$IMSPOOL= $RC{'spooldir'} ? $RC{'spooldir'} : "~/ImageMail" ;
$IMSPOOL=~s/\~/$ENV{HOME}/;
$ATFILE="$IMSPOOL/at_imgmail_script";
$ATLOCK="$IMSPOOL/at_imgmail_lockfile";
#
if( $ARGV[0] eq "" ){
	print(	"binary mail v$VERSION 1991,92,93,94 H.Ogasawara(COR.)\n",
		"usage: imagemail [-i] [-f] [-m <address>] <files..>\n",
		" imagemail <files..>             split only\n",
		" imagemail -m <addr> <files..>   split and send\n",
		" imagemail -f <file>             fj.binaries.x68000 post mode\n",
		"  option\n",
		"   -i   use ish (7bit)\n" );
	exit( 1 );
}
#
$mailflag= 0;
$ishmode= 0;
# option check
if( $ARGV[0] eq "-i" ){
	$ishmode= 1;
	shift;
}
if( $ARGV[0] eq "-f" ){
	while( $H_ADDRESS eq "" ){
		print( "Your mail address ?\n" );
		$H_ADDRESS= &datainput;
	}
	$H_ORIGIN= $RC{'deforigin'} ? $RC{'deforigin'} :
		sprintf( "%s %s <%s>", $H_ROMNAME, $H_JNAME, $H_ADDRESS );
	print( "default origin is $H_ORIGIN\n" );
	$H_ORIGIN=&changeparam( $H_ORIGIN );
	printf( "origin = '%s'\n", $H_ORIGIN );
	print( "default title is 'filename (part/all)'.\n" );
	$H_TITLE=&changeparam( $H_TITLE );
	shift;
}
if( $ARGV[0] eq "-m" ){
	$mailflag= 1;
	if( $ARGV[1] eq "" ){
		do{
			print( "mail address ?\n" );
			$SENDADDR= &datainput;
		}while( $SENDADDR eq "" );
	}else{
		$SENDADDR=$ARGV[1];
		shift;
	}
	shift;
	# create spool
	unless( -d $IMSPOOL ){
		print "create $IMSPOOL\n";
		mkdir( $IMSPOOL, 0700 );
	}
	unless( -r $ATLOCK ){
		unlink( $ATFILE );
	}
	unless( -r $ATFILE ){
		if( open( OFILE, ">$ATFILE" ) ){
			print( OFILE	"#!/bin/sh\n",
					"IMSPOOL=$IMSPOOL\n",
					"LOCKFILE=$ATLOCK\n",
					"WAIT=$SLEEPTIME\n" );
			while( <DATA> ){
				print OFILE;
			}
			close( OFILE );
		}else{
			print( "error\n" );
			exit( 1 );
		}
	}
}
while( $ARGV[0] eq "" ){
	print( "input file ?\n" );
	$ARGV[0]= &datainput;
}
foreach $name ( @ARGV ){
	unless( -r $name ){
		print( "Can't open $name.\n" );
		next;
	}
# convert to uuencode
	if( $ishmode == 0 ){
		system( "uuencode $name $name >$TEMPFILE" );
		$H_FORMAT=&formatcheck( $name ) . " + uuencode";
	}else{
#		system( "ish -s7 $name -f=$TEMPFILE" );
		system( "aish -7 -o $TEMPFILE $name" );
		$H_FORMAT=&formatcheck( $name ) . " + ish 7bit";
	}
# open file and count lines
	unless( open( PFILE, $TEMPFILE ) ){
		print( "Can't open $TEMPFILE.\n" );
		next;
	}
	for( $line= 0 ; <PFILE> ;){
		$line++;
	}
	seek( PFILE, 0, 0 );
	$all= int($line/$MAXLINE)+1;
	print( "$name -> split $all\n" );
# split file
	for( $part= 1; ! eof( PFILE ) ; $part++ ){
		if( $mailflag == 1 ){
			$count= 0;
			do{
				$outputname= "$IMSPOOL/$name.$part.$count";
				$outputadr= "$outputname.adr";
				$count++;
			}while( -r $outputname );
		}else{
			$outputname= sprintf( "%s_%d", $name, $part );
		}
		unless( open( OFILE, ">$outputname" ) ){
			print( "Can't open $outputname.\n" );
			last;
		}
# make header
		$mname=sprintf( "%s(%d/%d)", $name, $part, $all );
		$tname=sprintf( "%s (%d/%d)",
					$H_TITLE ? $H_TITLE : $name,
					$part, $all );
		print( "   $part  $outputname ..." );
		print( OFILE "title    $tname\n" );
		print( OFILE "origin   $H_ORIGIN\n" )  if $H_ORIGIN ne "";
		print( OFILE "address  $H_ADDRESS\n" ) if $H_ADDRESS ne "";
		print( OFILE "name     $H_ROMNAME\n" );
		print( OFILE "jname    $H_JNAME\n" ) if $H_JNAME ne "";
		print( OFILE "format   $H_FORMAT\n");
# insert signature
		&addsignature( OFILE );
# body
		printf( OFILE "%s part%02d/%d\n", $name, $part, $all );
		print( OFILE "BEGIN --$mname--cut here--\n" );
		for( $i= 0; <PFILE> ;){
			print( OFILE );
			if( ++$i >= $MAXLINE ){
				last;
			}
		}
		print( OFILE "END   --$mname--cut here--\n" );
		print( "ok.\n" );
		close( OFILE );
# send it!!!
		if( $mailflag == 1 ){
			unless( open( OFILE, ">$outputadr" ) ){
				print( "Can't open $outputadr.\n" );
				last;
			}
			printf( OFILE
				"#!/bin/sh\n" .
				"if [ -r %s ];then\n" .
					"mail -s '%s' %s < %s\n",
						$outputname,
						$tname,
						$SENDADDR,
						$outputname );
			if( $LOGFILE ne "" ){
				printf( OFILE
					'echo "`date` \'%s\' %s" >> %s' . "\n",
						$tname,
						$SENDADDR,
						$LOGFILE );
			}
			printf( OFILE
				"fi\n" .
				"rm -f %s %s\n",
					$outputname,
					$outputadr );
					
			close( OFILE );
		}
	}
	close( PFILE );
}
if( -r $TEMPFILE ){
	unlink( $TEMPFILE );
}
if( $mailflag == 1 ){
	unless( -r $ATLOCK ){
		@dd=localtime(time);
		$dd[1]+= 2;
		if( $dd[1] >= 60 ){
			$dd[2]++;
			$dd[1]-= 60;
			if( $dd[2] >= 24 ){
				print( "Can't set at TIME.\n");
				printf( ">>> at %d%2d $ATFILE\n",
							$dd[2], $dd[1] );
				exit( 1 );
			}
		}
		system( sprintf( "at -s %d%02d $ATFILE", $dd[2], $dd[1] ) );
	}
}
exit( 0 );
# Copyright 1991,92,93 Ogasaawra Hiroyuki (COR.)
# oga@dgw.yz.yamagata-u.ac.jp
#------------------------------------------------
# .adr format
# #!/bin/sh
# if [ -r datafile.mail ];then
# mail -s 'title' address < datafile.mail
# echo "`date` 'title' address" >> logfile
# fi
# rm -f $0 datafile.mail
__END__
#IMSPOOL=$HOME/.ImageMail
#LOCKFILE=$IMSPOOL/atscript_lock_file
#WAIT=1800
# 1993 by Ogasawara Hiroyuki (COR.)
if [ -r $LOCKFILE ]; then exit 0;else echo $$ > $LOCKFILE ;fi
while true
	do for name in $IMSPOOL/*.adr ; do
		if [ -r $name ] ;then . $name; sleep $WAIT
		else break 2; fi
	done
done
if [ -r $LOCKFILE ] ; then rm -f $LOCKFILE ; fi
exit 0
